# coding: utf-8

"""
    Veeroute.Delivery

    Veeroute Delivery API  # noqa: E501

    The version of the OpenAPI document: 3.10.176314
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from vrt_lss_delivery.configuration import Configuration


class Customer(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'location': 'Location',
        'time_windows': 'list[TimeWindow]'
    }

    attribute_map = {
        'location': 'location',
        'time_windows': 'time_windows'
    }

    def __init__(self, location=None, time_windows=None, local_vars_configuration=None):  # noqa: E501
        """Customer - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._location = None
        self._time_windows = None
        self.discriminator = None

        self.location = location
        self.time_windows = time_windows

    @property
    def location(self):
        """Gets the location of this Customer.  # noqa: E501


        :return: The location of this Customer.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Customer.


        :param location: The location of this Customer.  # noqa: E501
        :type location: Location
        """
        if self.local_vars_configuration.client_side_validation and location is None:  # noqa: E501
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def time_windows(self):
        """Gets the time_windows of this Customer.  # noqa: E501

        List of possible delivery time windows.  # noqa: E501

        :return: The time_windows of this Customer.  # noqa: E501
        :rtype: list[TimeWindow]
        """
        return self._time_windows

    @time_windows.setter
    def time_windows(self, time_windows):
        """Sets the time_windows of this Customer.

        List of possible delivery time windows.  # noqa: E501

        :param time_windows: The time_windows of this Customer.  # noqa: E501
        :type time_windows: list[TimeWindow]
        """
        if self.local_vars_configuration.client_side_validation and time_windows is None:  # noqa: E501
            raise ValueError("Invalid value for `time_windows`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                time_windows is not None and len(time_windows) > 100):
            raise ValueError("Invalid value for `time_windows`, number of items must be less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                time_windows is not None and len(time_windows) < 1):
            raise ValueError("Invalid value for `time_windows`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._time_windows = time_windows

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Customer):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Customer):
            return True

        return self.to_dict() != other.to_dict()
